'Bascom ATmega32, LCD, Memory und Tastenabfrage

$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 16
$swstack = 32
$framesize = 32
Baud = 9600

Declare Sub Test1
Declare Sub Test2
Declare Sub Test3
Declare Sub Test4

Dim Pwma As Integer
Dim Pwmb As Integer
Dim Kommando As Byte
Dim Hi As Byte
Dim Lo As Byte

Dim D As Word
Dim Dd As Word
Dim U As Single
Dim F1 As Word
Dim F2 As Word
Dim N As Byte
Open "com1:" For Binary As #1



'Config Timer0 = Timer , Prescale = 64
'Start Timer0

Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls
Locate 1 , 1
Lcd "AK Modul Bus"
Locate 2 , 1
Lcd "ES-M32"
Waitms 1500

S1 Alias Pind.2
S2 Alias Pind.3
S3 Alias Pind.6
S4 Alias Pind.7

Config Portd = &B00110000
Portd.2 = 1
Portd.3 = 1
Portd.6 = 1
Portd.7 = 1

Out1 Alias Portd.4
Out2 Alias Portd.5

Config Adc = Single , Prescaler = 64 , Reference = Off
Start Adc

Do
  Get #1 , Kommando

  If Kommando = 56 Then
    Dd = Getadc(0)
    Hi = High(dd)
    Put #1 , Hi
    Lo = Low(dd)
    Put #1 , Lo
  End If

  If Kommando = 64 Then
    Get #1 , Hi
    Get #1 , Lo
    Dd = 256 * Hi
    Dd = Dd + Lo
    F1 = Dd
    For N = 1 To 250
      D = Getadc(0)
      If D < F1 Then
        Porta.0 = 1                                         'laden
        Ddra.0 = 1
        Waitus 20
        Ddra.0 = 0
        Porta.0 = 0
      End If
      If D > F1 Then
        Ddra.0 = 1                                          'entladen
        Waitus 20
        Ddra.0 = 0
        Waitms 1
      End If
    Next N
  End If

  If Kommando = 1 Then
    Porta.1 = 1
    Ddra.1 = 1
    Waitms 600
    Ddra.1 = 0
    Porta.1 = 0
  End If

Loop







End